class monster {
  int sceneState;
  boolean sceneEnd, firstEncounter, monsterHugged;

  monster() {
    sceneState = 0;
    sceneEnd = false;
  }

  void display() {

    image(monsterBackground, 0, 0);
    if (monsterDead == false && monsterHugged == false) {
      shape(monsterImage, width/2, 200, 400, 400);
    }
    currentChar = "monster";
    currentCharAppearance = monsterAppearance;
    currentLocation = monsterLocation;
  }

  void action() {

    if (currentChar == "monster") {

      if (mousePressed && click == false && sceneEnd == true) {
        click = true;
        didOnce = false;
        state++;
        if (monsterHealth <= 0) {
          monsterDead = true;
        }
      }

      if (mousePressed && click == false && sceneEnd == false) {
        sceneState++;
        click = true;
        didOnce = false;
        if (monsterHealth <= 0) {
          monsterDead = true;
        }
      }

      if (sceneState == 0) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (monsterHugged == true) {
          text("There is no one here.", 30, 450);
          text("The emptiness fills you with rage! You scream unintelligibly into", 30, 490);
          text("the void.", 30, 530);
          if (nextChar == currentChar) {
            text("You hang out and keep screaming for a weirdly long time.", 30, 570);
          }
          else {
            text("Satisfied, you turn around and leave.", 30, 570);
          }
          sceneEnd = true;
        }

        if (monsterDead == true) {
          text("The monster's body lies rotting on the ground.", 30, 450);
          if (hug == true) {
            text("You activate your Special Hug ability! You wrap your arms and", 30, 490);
            text("cover the corpse in a warm embrace!", 30, 530);
            if (nextChar == currentChar) {
              text("Nothing happens. You leave before anyone sees what you did.", 30, 570);
            }
            else {
              text("Nothing happens. You stay and wonder why you did that.", 30, 570);
            }
          } // hug true end
          else if (hug == false) {
            if (nextChar == currentChar) {
              text("You decide to stay a bit longer to admire your handiwork.", 30, 490);
            }
            else {
              text("After spending some time reflecting on your incredible heroism", 30, 490);
              text("and remarkable good looks, you decide to move on.", 30, 530);
            }
            sceneEnd = true;
          } // hug == false end
        } // monsterDead true end

        if (hug == true & monsterDead == false && monsterHugged == false) {
          text("The " +monsterAppearance+ " seems ready to attack!", 30, 450);
          text("Before it makes a move, you rush in and use your Special Hug!", 30, 490);
        }

        if (hug == false && monsterDead == false && monsterHugged == false) {
          text("The " +monsterAppearance+ " monster lunges in to attack!", 30, 450);
        } // hug, monsterDead false end
      } // sceneState 0 end;

      if (sceneState == 1) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (hug == true && monsterDead == false) {
          text("The monster seems confused at first, but then its demeanor", 30, 450);
          text("softens. A single tear falls from its eye.", 30, 490);
        }

        if (hug == false && monsterDead == false) {
          if (didOnce == false) {
            println("monster damage");
            playerHealth--;
            monsterHealth = monsterHealth - playerDamage;
            didOnce = true;
          } // didOnce false end
          text("After the ensuing battle, you have "+playerHealth+" health points.", 30, 450);
          text("The monster has "+monsterHealth+" health points.", 30, 490);
        } // hug false, monsterDead false
      } // sceneState 1 end

      if (sceneState == 2) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (hug == true && monsterDead == false) {
          text("The monster speaks:", 30, 450);
          text("Thank you, kind human. I know I project an air of agression,", 30, 490);
          text("but its really just my way of reaching out for help. You're", 30, 530);
          text("the only one who has ever cared enough to love me!", 30, 570);
        } // hug true, monsterDead false end

        if (playerHealth <= 0) {
          text("You have died!", 30, 450);
          state = 24;
        }

        if (monsterDead == true && playerHealth > 0) {
          text("You've slain the monster!", 30, 450);
          if (nextChar == currentChar) {
            text("You decide to stay for a while and enjoy the feeling of victory.", 30, 490);
          }
          else {
            text("You run off into the distance, excited to tell everyone how about", 30, 490);
            text("how great you are!", 30, 530);
          }
          sceneEnd = true;
        }

        if (hug == false && monsterDead == false && sceneState == 2) {
          if (currentChar != nextChar) {
            text("You run away.", 30, 450);
            sceneEnd = true;
          }
          else {
            text("You decide to stay and continue fighting.", 30, 450);
            sceneEnd = true;
          } // else end
        } // hug, monsterDead false end
      } // sceneState 2 end

      if (sceneState == 3) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (hug == true && monsterDead == false) {
          text("Please, take this as a token of my appreciation... I don't need", 30, 450);
          text("it anymore...", 30, 490);
        } // hug true, monster dead false end
      } // sceneState 3 end

      if (sceneState == 4) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (hug == true && monsterDead == false) {
          text("The monster takes something off of its head and throws it to you!", 30, 450);
          text("It then turns around and walks dramatically into the sunset. You", 30, 490);
          text("look at what you now hold in your hand. It's the Helm of ", 30, 530);
          text("Monstrous Rage! You place it on your head.", 30, 570);
        } // hug true, monsterDead false end
      } // sceneState 4 end

      if (sceneState == 5) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (hug == true && monsterDead == false) {
          text("Suddenly all your thoughts begin to be overtaken by a blind and", 30, 450);
          text("murderous rage! Your last thought before you are transformed into", 30, 490);
          text("a violent and irrational psychopath is 'maybe this wasn't such a", 30, 530);
          text("good idea.'", 30, 570);
          helm = true;
          monsterHugged = true;
          sceneEnd = true;
        } // hug true, monsterDead false end
      } // sceneState 5 end
    } // currentChar = monster end
  } // action() end
} // class end

