class wizard 
{

  int annoyance, sceneState;
  boolean sceneEnd, firstEncounter, firstFightEncounter, wizardAngry, wizardFight, wizardHugged, increaseAnnoyance;

  wizard() {
    annoyance = 0;
    sceneState = 0;
    sceneEnd = false;
    firstEncounter = true;
    firstFightEncounter = true;
    wizardFight = false;
    wizardHugged = false;
  } //constructor end

  void display() {
    image(wizardBackground, 0, 0);
    if (wizardDead == false){
    shape(wizardImage, width/2, 200);
    }
    currentChar = "wizard";
    currentCharAppearance = wizardAppearance;
    currentLocation = wizardLocation;
  } // display() end

  void action() {

    if (currentChar == "wizard") {

      if (annoyance > 2) {
        wizardFight = true;
      }

      if (mousePressed && click == false && sceneEnd == true) {
        if (increaseAnnoyance == true) {
          annoyance ++;
        }
        if (wizardHealth <= 0) {
          wizardDead = true;
        }
        click = true;
        didOnce = false;
        state ++;
      }

      if (mousePressed && click == false && sceneEnd == false) {

        if (wizardHealth <= 0) {
          wizardDead = true;
        }
        sceneState++;
        if (increaseAnnoyance == true) {
          annoyance ++;
        }
        click = true;
        didOnce = false;
      }


      //1st dialogue boxes
      if (sceneState == 0) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (wizardDead == true) {
          text("The wizard's corpse lies crumpled up on the floor.", 30, 450);
          text("It's starting to smell a little bit. A fly hovers in the air.", 30, 490);
          if (nextChar == currentChar) {
            text("You poke it with a stick and wait to see if anything happens.", 30, 530);
            text("Nothing does, but you wait around anyway.", 30, 570);
          }
          else {
            text("You decide to leave before your gag reflexes fully kick in.", 30, 530);
          }
          sceneEnd = true;
        }

        if (wizardDead == false) {

          if (helm == true) {
            if (firstEncounter == true) {
              text("You see a " +wizardAppearance+ " wizard standing in", 30, 450);
              text("front of you. The helm's effects take hold! You let", 30, 490);
              text("out a bloodcurdling scream and start flailing your arms", 30, 530);
              text("wildly. The fight is on!", 30, 570);
              firstFightEncounter = false;
              wizardFight = true;
            }

            if (firstEncounter == false && firstFightEncounter == true) {
              text("It's the " +wizardAppearance+ " wizard. The helm's effects", 30, 450);
              text("take hold! 'Who's annoying now, you big jerk?!' you yell as", 30, 490);
              text("you forward brandishing your weapon.", 30, 530);
              firstFightEncounter = false;
              wizardFight = true;
            }
          } // helm end

          //fight encounter, whether due to helm or due to annoyance level
          if (wizardFight == true && helm == false) {

            if (firstFightEncounter = true) {
              text("The wizard speaks:", 30, 450);
              text("'So be it. Mine patience is at an end. Feel the wrath of", 30, 490);
              text("my dark power!' Uh oh. You really did it this time. You", 30, 530);
              text("ready yourself for the coming fight.", 30, 570);
            }
            else {
              text("The wizard is still angry! You get ready for another fight.", 30, 450);
            }
          } // wizardFight end

          //first encounter without the helm or cookie
          if (cookie == false && helm == false && wizardHugged == false) {
            if (annoyance == 0) {
              text("The wizard speaks:", 30, 450);
              text("Who doth enter my "+wizardLocation+" and interrupt my", 30, 490);
              text("ancient "+wizardAppearance+" magicks?", 30, 530);
              text("Leave, intruder, lest ye be the target of my next spell!", 30, 570);
              firstEncounter = false;
            } // annoyance 0 end

            if (annoyance == 1) {
              text("The wizard speaks:", 30, 450);
              //if the player encountered the wizard during the previous scene...
              if (lastChar == currentChar) {
                text("Art thou still here?", 30, 490);
              }
              else {
                //if the player didn't encounter the wizard during the previous scene
                text("Hast thou returned, annoying one?", 30, 490);
              }
              text("Thou art testing mine patience! Leave now or", 30, 530);
              text("suffer the consequences of thine stupidity!", 30, 570);
            } //annoyance 1 end

            if (annoyance == 2) {
              text("The wizard speaks:", 30, 450);
              //if the wizard was the last character
              if (lastChar == currentChar) {
                text("Argh! Why do you stand there like as to a fool?", 30, 490);
                //if the wizard wasn't the last character
              }
              else {
                text("'Tis thee?! Dost thou make thy currency by annoying wizards?", 30, 490);
              }
              text("Take this magical trinket and begone! But returneth not, or I shall", 30, 530);
              text("gladly supply the painful death which you so seem to desire!", 30, 570);
            } // annoyance 2 end
          } // cookie, helm & hug false end

          if (wizardHugged == true && helm == false) {
            text("The wizard speaks:", 30, 450);
            if (lastChar == currentChar) {
              text("'Tis wondrous to spend time with you, dearest one.", 30, 490);
            }
            else {
              text("Ah, 'tis you! The embrace we shared hast never left my mind!", 30, 490);
            }
          } // wizardHugged end
        } // wizardDead false end
      } // sceneState 0 end


      //2nd dialogue boxes
      if (sceneState == 1) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (wizardHugged == true) {
          if (currentChar == nextChar) {
            text("You stay and give the wizard a pity hug.", 30, 450);
          }
          else {
            text("You leave quickly before the wizard thinks you're interested.", 30, 450);
          }
          sceneEnd = true;
        }

        if (wizardFight == true && hug == false && cookie == false) {
          if (didOnce == false) {
            playerHealth = playerHealth - 2;
            wizardHealth = wizardHealth - playerDamage;
            didOnce = true;
          }
          text("After the ensuing fight you have "+playerHealth+ " health points.", 30, 450);
          text("The wizard has "+wizardHealth+" health points.", 30, 490);
          firstEncounter = false;
        }

        if (cookie == true && hug == false) {
          text("Suddenly, the wizard notices the Delicious Cookie that you carry.", 30, 450);
          text("'Ah! I have always had a taste for sweets! Give me that cookie and", 30, 490);
          text("I shall forgive all of thine transgressions!'", 30, 530);
          text("You hand the wizard the delicious cookie.", 30, 570);
        }

        if (hug == true && wizardHugged == false && helm == false) {
          text("But before the wizard can say another word, you activate", 30, 450);
          text("your Special Hug power. You reach out and ensnare the", 30, 490);
          text("wizard in an almost inhumanly warm embrace.", 30, 530);
        }

        if (cookie == false && helm == false && hug == false) {
          //2nd dialogue box for 3rd annoyance level
          if (annoyance == 0) {
            if (currentChar == nextChar) {
              text("He seems pretty angry, but your morbid sense of", 30, 450);
              text("curiosity compels you to stay a bit longer.", 30, 490);
            }
            else {
              text("Perhaps it would be best to leave the wizard", 30, 450);
              text("alone for the time being.", 30, 490);
              text("You decide to head somewhere else.", 30, 530);
            }
            sceneEnd = true;
            increaseAnnoyance = true;
          } // annoyance 0 end

          else if (annoyance == 1) {
            if (nextChar == currentChar) {
              text("The " +wizardAppearance+ " wizard seems like he's threatening you,", 30, 450);
              text("but you decide to hang around a bit longer just to see", 30, 490);
              text("what happens.", 30, 530);
            }
            else {
              text("Perhaps it would be best to leave the wizard", 30, 450);
              text("alone for the time being.", 30, 490);
              text("You decide to head somewhere else.", 30, 530);
            }
            sceneEnd = true;
            increaseAnnoyance = true;
          } // annoyance 1 end

          else if (annoyance == 2) {
            text("Wow! The wizard tossed you a magical sword! You will", 30, 450);
            text("now do twice as much damage with each attack.", 30, 490);
            playerDamage = 2;
          }
        } // fight, hug & cookie false end
      } // sceneState 1 end

      //3rd dialogue boxes
      if (sceneState == 2) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (wizardFight == true) {
          if (playerHealth <= 0) {
            text("You have died!", 30, 450);
            state = 24;
          }
          else
            if (wizardDead == true) {
              text("You have dealt the wizard a mortal blow!", 30, 450);
            }
            else if (wizardDead == false) {
              if (nextChar != currentChar) {
                text("You run away!", 30, 450);
              }
              else {
                text("You continue the fight!", 30, 450);
              }
              firstFightEncounter = false;
              sceneEnd = true;
            } // wizardDead false end
        } // wizardFight end

        if (cookie == true && hug == false) {
          text("The wizard gulps the cookie down with a series of sickening slurps.", 30, 450);
          text("At first he seems very happy, but then his eyes bulge and his skin", 30, 490);
          text("turns pale.", 30, 530);
          wizardDead = true;
        }

        if (hug == true && wizardHugged == false && helm == false) {
          text("You feel the wizard's demeanor soften almonst instantly.", 30, 450);
          text("You let him out of your arms, and he brings his eyes up to", 30, 490);
          text("gaze into yours. You start to pick up a weird vibe", 30, 530);
          text("from him.", 30, 570);
        }

        if (cookie == false && helm == false && hug == false && annoyance == 2) {
          //if wizard is not next char
          if (nextChar != currentChar) {
            text("You never guessed that being an annoying bastard", 30, 450);
            text("could pay so well! You run off clutching your new sword", 30, 490);
            text("to your chest and giggling maniacally.", 30, 530);
          }
          else {
            text("The wizard just gave you a prize for being irritating!", 30, 450);
            text("You think that maybe if you do more dumb stuff he'll give", 30, 490);
            text("you something else. You sidle up next to him and start", 30, 530);
            text("making weird noises in his ear.", 30, 570);
          }
          increaseAnnoyance = true;
          sceneEnd = true;
        }// cookie, helm & hug false end
      } // sceneState 2 end


      //4th dialogue boxes
      if (sceneState == 3) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (cookie == true && hug == false) {
          text("The wizard speaks:", 30, 450);
          text("Argh! Did yon cookies contain hazelnuts! I have severe nut", 30, 450);
          text("allergies! Why was there not a warning label?! You have killed", 30, 490);
          text("me! Foul knave! I curse you with the blackest of hexes!", 30, 530);
        }

        if (hug == true && wizardHugged == false) {
          text("The wizard speaks:", 30, 450);
          text("'None before thou hast shown me such tenderness. Mine heart", 30, 490);
          text("does swell with such emotion as I have never felt. Wilst thou", 30, 530);
          text("take this gift as a token of mine love?'", 30, 570);
        }
      } // sceneState 3 end


      if (sceneState == 4) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (wizardDead == true) {
          text("The wizard reaches into his robes and pulls out a dagger carved", 30, 450);
          text("with evil-looking designs. He brings the dagger to his wrist and", 30, 490);
          text("lets out a few drops of blood. His eyes turn pitch black and he", 30, 530);
          text("mutters several syllables in a forgotten tongue before finally dying.", 30, 570);
        }

        if (hug == true && wizardDead == false) {
          text("The wizard hands you a magical sword. Your attacks will now", 30, 450);
          text("deal 2 damage!", 30, 490);
          if (nextChar == currentChar) {
            text("You thank the wizard. He gazes at you lovingly. It's a bit creepy", 30, 530);
            text("but you stay, hoping he'll provide you with more magical items.", 30, 570);
          }
          else {
            text("You thank the wizard, and he gazes at you lovingly. You hope he", 30, 530);
            text("didn't get the wrong idea. You make an excuse and leave hastily.", 30, 570);
          }
          sceneEnd = true;
          playerDamage = 2;
          wizardHugged = true;
        }
      } // sceneState 4 end


      if (sceneState == 5) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (wizardDead == true) {
          text("You're sure it's nothing to worry about.", 30, 450);
          if (nextChar == currentChar) {
            text("But you stick around to make sure the old man is truly dead.", 30, 490);
          }
          else {
            text("You step over the wizard's body and make for the door.", 30, 490);
          }
          if (playerDamage == 1) {
            text("Something in the wizard's robe catches your eye. It's a magical sword!", 30, 530);
            text("Your attacks will now deal 2 damage! Great!", 30, 570);
            playerDamage = 2;
          }
          sceneEnd = true;
          cookie = false;
        } // wizardDead == true end
      } // sceneState 5 end
    } // action() end
  } // currentChar == wizard end
} // class end

