class fairy
{
  int sceneState, rightAnswer;
  boolean firstEncounter, sceneEnd, correct;

  fairy()
  {
    sceneState = 0;
    firstEncounter = true;
    sceneEnd = false;
  }

  void display() {

    image(fairyBackground, 0, 0);
    
    if (fairyDead == false)
    {
      shape(fairyImage, width/2, 200);
    }
    currentChar = "fairy";
    currentCharAppearance = fairyAppearance;
    currentLocation = fairyLocation;
    correct = false;
  }


  void action()
  {

    if (currentChar == "fairy") {

      if (mousePressed && click == false && sceneEnd == true) {
        click = true;
        didOnce = false;
        state = state + 1;
        firstEncounter = false;
      }

      if (mousePressed && click == false && sceneEnd == false) {
        sceneState++;
        click = true;
        didOnce = false;
      }

      if (sceneState == 0)
      {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (net == true && enslavedVillager == true)
        {
          text("The fairy speaks:", 30, 450);
          text("Ah! You have done it! I can almost taste the endless stream of cookies", 30, 490);
          text("right now! Give me the villager!", 30, 530);
        }

        if (fairyDead == true)
        {
          text("You state at the dead fairy and contemplate the morality of your", 30, 450);
          text("actions. Or you would, that is, if you weren't consumed with", 30, 490);
          text("Helm's power.", 30, 530);
          if (nextChar == currentChar)
          {
            text("Instead you randomly kick a few inanimate objects and leave.", 30, 570);
          }
          else
          {
            text("Instead you hang around and randomly kick inanimate objects.", 30, 570);
          }
          sceneEnd = true;
        }

        if (fairyDead == false)
        {

          if (helm == true)
          {
            text("You see the fairy standing in front of you. The Helm's effects", 30, 450);
            text("take hold! You run forwards brandishing your weapon! The fairy", 30, 490);
            text("gets ready to meet you in combat!", 30, 530);
            if (didOnce == false)
            {
              playerHealth --;
              fairyHealth = fairyHealth - playerDamage;
            }
          }

          if (net == true && enslavedVillager == true) {
            text("The fairy speaks:", 30, 450);
            text("Ah! You have done it! I can almost taste the endless stream of cookies", 30, 490);
            text("right now! Give me the villager!", 30, 530);
          }

          if (cookie == true && helm == false) {
            text("The fairy is about to speak, but suddenly stops and begins", 30, 450);
            text("sniffing the air frantically.", 30, 490);
          } // cookie == true, helm == false end

          if (hug == true && cookie == false && helm == false) {
            text("Before the fairy can say anything, you reach out and", 30, 450);
            text("give it a loving hug. The fairy returns it and speaks:,", 30, 490);
            text("Why thank you, hero! Now please allow me to return your kindness", 30, 530);
            text("with my healing magic!", 30, 570);
            if (didOnce == false) {
              println("fairy heal");
              playerHealth ++;
              didOnce = true;
            }
          } // hug == true, cookie, helm == false end

          if (helm == false && cookie == false && hug == false) {
            if (firstEncounter == true) {
              text("The fairy speaks:", 30, 450);
              text("Welcome, brave wanderer! I am the magical "+fairyAppearance+" fairy!", 30, 490);
              text("Please allow me to heal your wounds!", 30, 530);
            }
            else {
              text("Welcome back, brave wanderer! Do you need", 30, 450);
              text("more healing?", 30, 490);
            }
            if (didOnce == false) {
              println("fairy heal");
              playerHealth ++;
              didOnce = true;
            }
          } // helm, cookie, hug false end
        } // fairyDead == false end
      } // sceneState 0 end

      if (sceneState == 1) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (helm == true) {
          text("After the ensuing battle, you have "+playerHealth+" health points.", 30, 450);
          text("The fairy has "+fairyHealth+" health points.", 30, 490);
          if (playerHealth <= 0) {
            text("You have died!", 30, 530);
          }
        }

        if (fairyDead == false) {

          if (net == true && enslavedVillager == true) {
            text("You hand over the villager. The fairy opens the net and shakes it into a cage,", 30, 450);
            text("then quickly shuts and locks the door. The cage contains a little oven and fully", 30, 490);
            text("stocked kitchen. The villager sighs and gets to work.", 30, 530);
          }

          if (cookie == true && helm == false) {
            text("The fairy speaks:", 30, 450);
            text("Oh my! Is that what I think it is?! Is that one of the cookies of the", 30, 490);
            text(villagersAppearance+ " villagers? Please! I beg of you! I must have that", 30, 530);
            text("cookie!", 30, 570);
          }

          if (helm == false && cookie == false) {
            text("The fairy casts healing magic upon you, and you gain health.", 30, 450);
            text("Your now have "+playerHealth+" health points.", 30, 490);
            text("What a kind fairy!", 30, 530);
          }
        } // fairyDead == false end
      } // sceneState 1 end

      if (sceneState == 2) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (net == true && enslavedVillager == true) {
          text("The fairy speaks:", 30, 450);
          text("You truly are a great hero! Soon I shall control the production of cookies. They", 30, 490);
          text("have always said that he who controls the flow of cookies controls the flow", 30, 530);
          text("of history. Yes... a new era shall dawn. One in which the fairy is Queen!", 30, 590);
        }

        if (helm == true) {
          if (fairyDead == true) {
            text("The fairy lies dead! You roar loudly in triumph! Suddenly you", 30, 450);
            text("notice something shiny in the fairy's posession. It's the Legendary", 30, 490);
            text("Treasure of Numinous Wonder, the most powerful object in the universe.", 30, 530);
            text("With this item, your journey would be triumphant!", 30, 590);
          }
          else {
            if (currentChar == nextChar) {
              text ("You decide to stay and continue fighting!", 30, 450);
            }
            else {
              text("You run away!", 30, 450);
            }
            sceneEnd = true;
          }
        }

        if (cookie == true && helm == false) {
          text("You shrug and hand over your Delicious Cookie to the fairy.", 30, 450);
          text("The fairy grabs it frantically and begins slurping it down in a", 30, 490);
          text("manner that is, frankly, disturbing.", 30, 530);
        }

        if (hug == false && cookie == false && helm == false) {
          text("The fairy speaks:", 30, 450);
          text("Before you go, wanderer, let me ask you a riddle!", 30, 490);
          text("If you answer correctly, I shall bestow upon you", 30, 530);
          text("a special power!", 30, 570);
          riddleGuesses.shuffle();
        }
        else
          if (hug == true && cookie == false && helm == false) {
            if (nextChar != currentChar) {
              text("Thanking the fairy, you return to your wanderings.", 30, 450);
            }
            else {
              text("You decide to stick around to see if the fairy will", 30, 450);
              text("heal you again.", 30, 490);
            }
            sceneEnd = true;
          }
      }

      if (sceneState == 3) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (fairyDead == true) {
          text("But under the influence of the Helm, you are unable to recognize it.", 30, 450);
          if (currentChar == nextChar) {
            text("You smash it under your foot and pound your chest in an ape-like fashion.", 30, 490);
          } 
          else {
            text("You smash it under your foot and leave.", 30, 490);
          }
          sceneEnd = true;
        }

        if (net == true && enslavedVillager == true) {
          text("The fairy speaks:", 30, 450);
          text("Here, take this treasure. You have earned it, and besides, I have no need of", 30, 490);
          text("such items any more. I have everything I need right here.", 30, 530);
        }

        if (cookie == true && helm == false) {
          text("The fairy speaks:", 30, 450);
          text("Thank you, kind sir! It has been too long since I tasted", 30, 490);
          text("that luscioius flavor. You see... the other fairies have kept", 30, 530);
          text("me from tasting them since... the incident...", 30, 570);
        } // cookie = true, helm = false end

        if (hug == false && cookie == false) {
          text("The fairy asks you the riddle. It's a tough one.", 30, 450);
          text("After some deep thought, you reply:", 30, 490);
          riddleGuess = riddleGuesses.get(0);
          text("'"+riddleGuess+"'", 30, 530);
          rightAnswer = int(random(1, 7));
        }
      }

      if (sceneState == 4) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);
        if (rightAnswer == 2) {
          correct = true;
        }

        if (net == true && enslavedVillager == true) {
          text("The fairy hands you the Legendary Treasure of Numinous Wonder. You have done", 30, 450);
          text("what no other hero has dared to dream! You posess the most powerful item in", 30, 490);
          text("the entire multiverse! You look down at the glowing treasure in your hands.", 30, 530);
        }

        if (cookie == true && helm == false) {
          text("But don't worry about that! Listen, I try to keep this", 30, 450);
          text("information secret, but I am the keeper of the Legendary", 30, 490);
          text("Treasure of Numinous Wonder. If you can get me a reliable", 30, 530);
          text("supply of those cookies, it's yours, no questions asked.", 30, 570);
        } // cookie = true, helm = false end

        if (hug == false && correct == true && cookie == false) {
          text("The fairy looks impressed!", 30, 450);
          text("'Congratulations, wise one!", 30, 490);
          text("'"+riddleGuess+"' is the answer!'", 30, 530);
          text("I now grant you a most powerful ability!", 30, 570);
        }
        if (hug == false && correct == false && cookie == false) {
          text("The fairy shakes its head condescendingly.", 30, 450);
          text("'Haha! Wait... you're serious? Uh... no...", 30, 490);
          text("'"+riddleGuess+"' is not correct.'", 30, 530);
          text("I guess you can try again text time... if you want.'", 30, 570);
        }
      }

      if (sceneState == 5) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (rightAnswer == 2) {
          correct = true;
        }

        if (net == true && enslavedVillager == true) {
          text("It's a burrito. You take a bite.", 30, 450);
        }

        if (cookie == true && helm == false) {
          text("I'll just give you this net... let's just say it's good for", 30, 450);
          text("catching small, helpless creatures. You can do with it as you", 30, 490);
          text("wish, but remember that my offer stands. Here, have some healing", 30, 530);
          text("magic for your trouble.", 30, 570);
          if (didOnce == false) {
            println("fairy heal");
            playerHealth ++;
            didOnce = true;
          }
        } // cookie = true, helm = false end

        if (correct == true && cookie == false) {
          text("You have gained the Special Hug power!", 30, 450);
          text("You can now envelop unsuspecting passerby in a", 30, 490);
          text("warm, motherly embrace! It's sure to warm even", 30, 530);
          text("the most wicked heart!", 30, 570);
          hug = true;
        }
        if (correct == false) {
          if (nextChar != currentChar) {
            text("You leave quickly, hoping to avoid further embarassment.", 30, 450);
          }
          else if (nextChar == currentChar) {
            text("Though embarassed, you decide to stick around.", 30, 450);
            text("Maybe the fairy will at least heal you again.", 30, 490);
          }
          sceneEnd = true;
        }
      } // sceneState 5 end

      if (sceneState == 6) {
        fill(0);
        rect(0, 400, width, height);
        fill(255);

        if (rightAnswer == 2) {
          correct = true;
        }

        if (net == true && enslavedVillager == true) {
          text("It's the most delicious burrito you've ever tasted! You take another bite", 30, 450);
          text("and are awash in a reverie of incredible flavor. With every bite you take,", 30, 490);
          text("the other end of the burrito grows longer. It's an infinite burrito!", 30, 530);
        }

        if (cookie == true && helm == false) {
          text("The fairy casts healing magic upon you, and you gain health.", 30, 450);
          text("Your now have "+playerHealth+" health points.", 30, 490);
          if (currentChar == nextChar) {
            text("You decide to stick around for more healing while you consider", 30, 530);
            text("the fairy's offer.", 30, 590);
          }
          else {
            text("You tell the fairy that you'll consider it's offer and leave", 30, 539);
            text("thoughtfully.", 30, 450);
          }
          sceneEnd = true;
          cookie = false;
          net = true;
        } // cookie = true, helm = false end

        if (correct == true && cookie == false) {
          if (nextChar != currentChar) {
            text("Feeling like a pretty smart guy, you", 30, 450);
            text("continue triumphantly on your adventures.", 30, 490);
          }
          else {
            text("Wow, look at Mr. Smart Guy over here!", 30, 450);
            text("You start to think that maybe your Mom was right", 30, 490);
            text("and you really are special. You stick around a", 30, 530);
            text("bit longer, wanting to bask in the fairy's approval.", 30, 570);
          }
          sceneEnd = true;
        } // correct == true end
      } // sceneState 6 end

      if (sceneState == 7) {
        if (net == true && enslavedVillager == true) {
          if (wizardCurse == true) {
            text("Suddenly you hear a strange voice in your head. It's the wizard's death", 30, 450);
            text("curse come back to haunt you! Suddenly the chunk of burrito in your mouth", 30, 490);
            text("squrims as if it has a life of it's own. It jumps down your trachea! You", 30, 530);
            text("slowly choke to death.", 30, 570);
          } 
          else {
            text("Your life is complete. There is honestly nothing you can imagine that would", 30, 450);
            text("top this current experience. You retire into the country side, living a quiet", 30, 490);
            text("life full of the never-ending enrichment that only a burrito can provide.", 30, 530);
          }
        } // net, enslaved villager true
      } // sceneState 7 end

      if (sceneState == 8) {
        if (net == true && enslavedVillager == true) {
          if (wizardCurse == true) {
            state = 24;
          } 
          else {
            state = 25;
          }
        } // net, enslaved villager true
      } // sceneState == 8 end
    } // currentChar == fairy end
  } // action() end
} // class end

